////////////////////////////////////////////////////////////////////////////////////
//
//			http://www.interestprograms.ru - ,     
//
/////////////////////////////////////////////////////////////////////////////////////


#include "StdAfx.h"
#include ".\controlbuttons.h"
#include "CubeRubika3.h"

CControlButtons::CControlButtons(void)
: m_pd3dSprite(NULL)
, m_pTexture(NULL)
, m_IsActive(false)
, m_ActiveButton(-1)
, m_IsDown(false)
, m_TransparentControlButtons(FALSE)
{
	
}

CControlButtons::~CControlButtons(void)
{
	SAFE_RELEASE(m_pd3dSprite);
	SAFE_RELEASE(m_pTexture);
}

//    CControlButtons, 
//  ,  ,  
//   .
HRESULT CControlButtons::InitControlButtons(LPDIRECT3DDEVICE9 pd3dDevice)
{
	//   (),     ,
	//  ,      ,
	// -     D3D ,  - -.
	HRESULT hr = D3DXCreateSprite(pd3dDevice, &m_pd3dSprite);
	if(hr != NULL) return hr;

	//  	    2   n,
	//       
	hr = D3DXCreateTextureFromResource(pd3dDevice, AfxGetApp()->m_hInstance, 
		MAKEINTRESOURCE(IDR_BUTTONS), &m_pTexture);



	//       
	//   .
	m_rcTexture[tbFullScreen].SetRect(0,   0, 104,  25);
	m_rcTexture[tbWindowed].SetRect(  0,  25, 104,  50);
	m_rcTexture[tbNewGame].SetRect(   0,  50, 104,  75);
	m_rcTexture[tbEducation].SetRect( 0,  75, 104, 100);
	m_rcTexture[tbReset].SetRect(     0, 100, 104, 125);
	
	m_rcTexture[tbColorBG].SetRect(   0, 125, 104, 150);
	m_rcTexture[tbColorFont].SetRect( 0, 150, 104, 175);
	m_rcTexture[tbImageBg].SetRect(   0, 175, 104, 200);
	m_rcTexture[tbPlayerName].SetRect(0, 200, 104, 225);
	m_rcTexture[tbSetting].SetRect(   0, 225, 104, 250);
	m_rcTexture[tbHelp].SetRect(      0, 250, 104, 275);
	m_rcTexture[tbExit].SetRect(      0, 275, 104, 300);

	//     
	//   .
	m_rcPos[tbFullScreen].SetRect(20,  20, 124,  45);
	m_rcPos[tbWindowed].SetRect(  20,  20, 124,  45);
	m_rcPos[tbNewGame].SetRect(   20,  50, 124,  75);
	m_rcPos[tbEducation].SetRect( 20,  80, 124, 105);
	m_rcPos[tbReset].SetRect(     20, 110, 124, 135);
	
	m_rcPos[tbColorBG].SetRect(   20, 180, 124, 205);
	m_rcPos[tbColorFont].SetRect( 20, 210, 124, 235);
	m_rcPos[tbImageBg].SetRect(   20, 240, 124, 265);
	m_rcPos[tbPlayerName].SetRect(20, 270, 124, 295);
	m_rcPos[tbSetting].SetRect(   20, 300, 124, 325);
	m_rcPos[tbHelp].SetRect(      20, 330, 124, 355);
	m_rcPos[tbExit].SetRect(      20, 360, 124, 385);
	

	//      (  )
	//     .
	for(int i = 0; i < NUMBERBUTTONS; i++)
	{
		m_ptDownButton[i].x = m_rcPos[i].left + 12;
		m_ptDownButton[i].y = m_rcPos[i].top  + 2;

		m_LeftActiveButton[i] = m_rcPos[i].left + 10;
	}

	return hr;
}

//     
HRESULT CControlButtons::Render(LPDIRECT3DDEVICE9 pd3dDevice, BOOL fullscreen)
{

	if(m_pd3dSprite == NULL) return D3DERR_INVALIDCALL;

	HRESULT hr = S_OK;

	//      m_FullScreen
	//    
	//       
	//    .
	m_FullScreen = fullscreen;

	m_pd3dSprite->Begin(D3DXSPRITE_ALPHABLEND);
	
	//           
	//          .
	//      .
	// .CControlButtons::HandleMouse().
	if(m_FullScreen == TRUE)
		RenderButton(pd3dDevice, tbWindowed);
	else
		RenderButton(pd3dDevice, tbFullScreen);

	//      .
	RenderButton(pd3dDevice, tbNewGame);
	RenderButton(pd3dDevice, tbEducation);
	RenderButton(pd3dDevice, tbReset);

	RenderButton(pd3dDevice, tbColorBG);
	RenderButton(pd3dDevice, tbColorFont);
	RenderButton(pd3dDevice, tbImageBg);
	RenderButton(pd3dDevice, tbPlayerName);
	RenderButton(pd3dDevice, tbSetting);
	RenderButton(pd3dDevice, tbHelp);
	RenderButton(pd3dDevice, tbExit);
	

	m_pd3dSprite->End();


	return hr;
}

//     ,    ,
//      (, , ), 
//        .
HRESULT CControlButtons::RenderButton(LPDIRECT3DDEVICE9 pd3dDevice, typeButton tbButton)
{
	if(m_pd3dSprite == NULL) return D3DERR_INVALIDCALL;

	HRESULT hr = S_OK;

	float y = (float)m_rcPos[tbButton].top;
	D3DXVECTOR3 pos = D3DXVECTOR3( (float)m_rcPos[tbButton].left, y, 0);


	//      .
	static float alpha = 255.0f;

	//   ,   .
	if(m_IsActive == false)
	{	 
		//     ...
		if(m_TransparentControlButtons == TRUE)
		{
			//   ,   
			//     .
			if(alpha > 0.0f)
				alpha -= 0.2f;
		}

		m_pd3dSprite->Draw(m_pTexture, &m_rcTexture[tbButton], NULL, &pos, 
			D3DCOLOR_ARGB((int)alpha, 255,255,255));
	}
	else
	{
		//      ,
		//    .
		if(m_ActiveButton == tbButton)
		{
			float x = (float)m_LeftActiveButton[tbButton];
			
			//     ,
			//       .
			if(m_IsDown == true)
			{
				y = (float)m_ptDownButton[tbButton].y;
				x = (float)m_ptDownButton[tbButton].x;
				
			}
			pos = D3DXVECTOR3(x, y, 0);
		}

		//    255  ( 100%),
		//    .
		if(alpha < 253.0f)
			alpha += 2.0f;

		m_pd3dSprite->Draw(m_pTexture, &m_rcTexture[tbButton], NULL, &pos, 
			D3DCOLOR_ARGB((int)alpha, 255,255,255));
	}

	return hr;
}

void CControlButtons::HandleMouse(POINT point, int* tbButton, bool mousedown)
{
	//    ,
	//     .
	m_ActiveButton = -1;

	for(int i = 0; i < NUMBERBUTTONS; i++)
	{
		//       .
		if(m_rcPos[i].PtInRect(point) == TRUE)
		{
			//    
			*tbButton = m_ActiveButton = i;
			
			//       tbFullScreen (    ),
			//       tbWindowed (    ),
			//       .
			if(i == 0 && m_FullScreen == FALSE)
				m_ActiveButton = 0;
			if(i == 0 && m_FullScreen == TRUE)
				m_ActiveButton = 1;

			break;
		}
		
	}  


	//     ,   ,
	//    ,
	//    ,   .
	//      
	//       
	//    ,       .
	CRect rc;
	rc.left	  = m_rcPos[0].left - 100;
	rc.right  = m_rcPos[0].right;
	rc.top	  = m_rcPos[0].top - 100;
	rc.bottom = m_rcPos[NUMBERBUTTONS-1].bottom + 1000;
	if(rc.PtInRect(point) == TRUE)
	{
		m_IsActive = true;
	}
	else
	{
		m_IsActive = false;
	}

	m_IsDown = mousedown;

}


//     (lost) 3D-, 
//   (reset) 3D-.
HRESULT CControlButtons::Invalidate(void)
{
	if(m_pd3dSprite == NULL) return D3DERR_INVALIDCALL;

	return m_pd3dSprite->OnLostDevice();
}



//   (reset) 3D-,    
//   .
HRESULT CControlButtons::Restore(void)
{
	if(m_pd3dSprite == NULL) return D3DERR_INVALIDCALL;

	return m_pd3dSprite->OnResetDevice();
}

//   .
void CControlButtons::DataToRegistry(HKEY hKey)
{
	GlobalNumberToRegKey(hKey, "TransparentControlButtons", m_TransparentControlButtons);
}


//   .
void CControlButtons::DataFromRegistry(HKEY hKey)
{
	GlobalNumberFromRegKey(hKey, "TransparentControlButtons", (DWORD*)&m_TransparentControlButtons, FALSE);
}

