#pragma once
#include <vector>
#include <algorithm>


//     .
struct DATAINTERSECT
{
	float distance;
	int   numberrotate;
};

//     
//   -.
struct PARSEMESH
{
	PARSEMESH(){pMesh = NULL; pTextures = NULL; pMaterials = NULL; dwNumMaterials = 0;}

	LPD3DXMESH pMesh;
	LPDIRECT3DTEXTURE9* pTextures;
	D3DMATERIAL9* pMaterials;
	DWORD dwNumMaterials;
};



//      
//      ,
// ,   . .
struct CUSTOMVERTEX_CONTROL
{
    D3DXVECTOR3 vector3;
};

#define D3DFVF_CUSTOMVERTEX_CONTROL (D3DFVF_XYZ)


//      .
class CCubeRube
{
public:
	CCubeRube(void);
	~CCubeRube(void);

	HRESULT InitXFile(LPDIRECT3DDEVICE9, CWnd* pParent);
	HRESULT Render(LPDIRECT3DDEVICE9 pd3dDevice, D3DXMATRIX world);
	void BackRotate(void);
	void DataToRegistry(HKEY hKey);
	void DataFromRegistry(HKEY hKey);
	void DoShuffleRotation(int number_rotate);
	void DoShuffleRotationEducation(void);   
	//    
	void PerformRotateFrame(CWnd* pParent);
	void PrepareNewGame(void);
	bool RotateFrame(void);
	void Shuffle();	
	//         
	void StateCubeForEducation(int state);
	
	int m_CountShuffleRotateEducation;

private:  
	bool BeginRotateFrame(bool backrotate);
	BOOL CalculateIntersect(int width, int height, D3DXMATRIX world, 
								  D3DXMATRIX view, D3DXMATRIX proj, int* number_rotate);
	HRESULT InitControlVertex(LPDIRECT3DDEVICE9 pd3dDevice);
	HRESULT InitPsevdoMesh(LPDIRECT3DDEVICE9 pd3dDevice);
	int GetNumberBackRotate(int rotate);
	HRESULT AddLight(LPDIRECT3DDEVICE9 pd3dDevice, float x, float y, float z, int index);
	HRESULT LoadMesh(LPDIRECT3DDEVICE9 pd3dDevice, LPD3DXFILEDATA pFileData);
	HRESULT GetMeshs(LPDIRECT3DDEVICE9 pd3dDevice, LPD3DXFILEDATA pFileData);
	bool CheckCubeComplect(void);
	void RestoreShuffle(void);


	//     .
	LPDIRECT3DVERTEXBUFFER9 m_pvbControl;


	D3DXMATRIX* m_pmatFramesMemory;
	LPD3DXMESH m_pPsevdoMesh; 
	bool m_IsRotate;
	int m_NumberFrame;
	std::vector<int> m_vecBackRotate;
	std::vector<PARSEMESH*> m_vecParseMesh;
	std::vector<D3DXMATRIX*> m_vecMatrixs;
	D3DXMATRIX m_World;
	//      
	CUSTOMVERTEX_CONTROL* m_pControlVertices; 
	CWnd* m_pParent;
	D3DXMATRIX m_matRotate;
	int m_CountShuffleRotate;
	bool m_IsShuffle;
	bool m_ModeGame;
	
};
