////////////////////////////////////////////////////////////////////////////////////
//
//			www.interestprograms.ru - ,     
//
/////////////////////////////////////////////////////////////////////////////////////

// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "CubeRubika3.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_ACTIVATE()
//	ON_WM_TIMER()
//ON_WM_SIZE()
ON_WM_CLOSE()
ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	
}

CMainFrame::~CMainFrame()
{	
	
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;


	//   Direct3D 3D-, !       
	//           
	CRect rc_initchildview;
	GetClientRect(&rc_initchildview);

	if (!m_wndView.Create(NULL, NULL, WS_CHILD|WS_VISIBLE,
		rc_initchildview, this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	 SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), TRUE);

	 DataFromRegistry();
	
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers

void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	// forward focus to the view window
	m_wndView.SetFocus();
	
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	

	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	CFrameWnd::OnActivate(nState, pWndOther, bMinimized);

	//    3D 
	//       ,
	//  ,   ,   
	//         
	if(nState == WA_INACTIVE)
	{
		m_wndView.m_IsActive = false;
	}
	else 
	{
		//     OnPaint(),
		//       .
		m_wndView.Invalidate();

		if(nState == WA_ACTIVE || nState == WA_CLICKACTIVE)
			m_wndView.m_IsActive = true;

		//    (   Alt+Tab)
		//   3D
		m_wndView.ResetScene();
	}
}


void CMainFrame::DataToRegistry(void)
{
	HKEY hKey;
    if(ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, REGKEY, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKey, NULL))
    {
		WINDOWPLACEMENT wp;
		GetWindowPlacement(&wp);
		GlobalBinaryToRegKey(hKey, "WindowPlacement", (BYTE*)&wp, sizeof(WINDOWPLACEMENT));
		
		RegCloseKey(hKey);
    }
}

void CMainFrame::DataFromRegistry(void)
{
	HKEY hKey;
    if(ERROR_SUCCESS == RegCreateKeyEx( HKEY_CURRENT_USER, REGKEY, 
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hKey, NULL))
    {
		WINDOWPLACEMENT wp;
		ZeroMemory(&wp, sizeof(WINDOWPLACEMENT));
		int screen_width  = GetSystemMetrics(SM_CXSCREEN);
		int screen_height = GetSystemMetrics(SM_CYSCREEN);

		int left = screen_width/2  - 800/2;
		int top  = screen_height/2 - 600/2;
		SetRect(&wp.rcNormalPosition, left, top, left + 800, top + 600); 
		GlobalBinaryFromRegKey(hKey, "WindowPlacement", (BYTE*)&wp, sizeof(WINDOWPLACEMENT), (BYTE*)&wp);
		SetWindowPlacement(&wp);

        RegCloseKey( hKey );
    }
}

void CMainFrame::OnClose()
{
	//       ,
	//       
	//   (    ),
	//       .
	WINDOWPLACEMENT WndPlacement;
	//      
	GetWindowPlacement(&WndPlacement);
	int screen_width  = GetSystemMetrics(SM_CXSCREEN);
	int screen_height = GetSystemMetrics(SM_CYSCREEN);


	//          
	//  ,         .
	CRect rc(&WndPlacement.rcNormalPosition);
	if(	rc.left < 50 && rc.top < 50 && 
		rc.right > (screen_width-50) && rc.bottom > (screen_height-50))
	{
		int left = screen_width/2  - 800/2;
		int top  = screen_height/2 - 600/2;
		SetRect(&WndPlacement.rcNormalPosition, left, top, left + 800, top + 600); 
		
	}
	WndPlacement.showCmd = SW_RESTORE;

	//     .
	SetWindowPlacement(&WndPlacement);




	DataToRegistry();

	CFrameWnd::OnClose();
}

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	//lpMMI->ptMinTrackSize.x = 1024;
	//lpMMI->ptMinTrackSize.y = 768;

	CFrameWnd::OnGetMinMaxInfo(lpMMI);
}
